#include <stdio.h>
#include <netdb.h>
#include <netinet/in.h>         /* voor AF_INET */

void printhost(struct hostent *host)
{
        if (!host) {
                puts("geen hostent!");
                return;
        }

        printf("hostnaam: %s\n",host->h_name);

        /* aliases */
        {
                int aantal = 0;
                while (1) {
                       char *alias = host->h_aliases[aantal];
                       if (!alias) break;
                       printf("alias %s\n",alias);
                       aantal++;
                }
        }

        /* ip adressen */
        {
                int aantal = 0;
                while (1) {
                        unsigned char *ipadres = host->h_addr_list[aantal];
                        int tel;
                        if (!ipadres) break;

                        printf("ip adres ");
                        /* het adres bestaat uit host->h_length bytes */
                        for (tel = 0; tel < host->h_length-1; tel++)
                                printf("%d.",ipadres[tel]);
                        printf("%d\n",ipadres[tel]);
                        aantal++;
                }
        }
}

int main(void)
{
        unsigned char adres[] = { 157,193,41,38 };

        printhost(gethostbyname("zeus.rug.ac.be"));
        puts("--------");
        printhost(gethostbyaddr(adres,4,AF_INET));
        return 0;
}
