#include "argumenten.h"
#include "escape.h"
#include "letter.h"

static int blz = 1;
static int regel = 0;     /* loopt van 0 t/m hoog-1 */
static int positie = 0;   /* loopt van 0 t/m breed-1 */

/* geeft 1 als deze pagina afgedrukt moet worden, anders 0 */
static int drukmij(void)
{
        return vanblz<=blz && blz<=totblz;
}

static void hoofding(void)
{
        /* %40.40s: maximum 40 letters en aanvullen met spaties tot 40 letters */
        if (drukmij()) printf("%40.40s Bladzijde %5d\n",bestandsnaam,blz);
        regel++;    /* de hoofding neemt 1 regel in */
}

static void drukc(char c)
{
        if (drukmij()) putchar(c);
}

static void druks(char *s)
{
        if (drukmij()) printf("%s",s);
}

void verwerkLetter(char c)
{
        static char vorige = 0;
        static int inCommentaar = 0;

        if (regel == 0) {
                /* Bovenste regel van het blad: druk een hoofding */
                /* Indien nodig vet even onderbreken */
                if (inCommentaar) druks(TXT_NORMAAL);
                hoofding();
                if (inCommentaar) druks(TXT_VET);
        }
        switch(c) {
                case '\n':
                        drukc(c);
                        positie = 0;
                        regel++;
                        break;
                case '\t':
                        do {
                                drukc(' '); positie++;
                        } while (positie%tab != 0);
                        break;
                case '*':
                        drukc('*');
                        if (!inCommentaar && vorige=='/') {
                                /* Commentaartekst begint */
                                inCommentaar = 1;
                                druks(TXT_VET);
                        }
                        positie++;
                        break;
                case '/':
                        drukc('/');
                        if (inCommentaar && vorige == '*') {
                                /* Einde commentaartekst */
                                inCommentaar = 0;
                                druks(TXT_NORMAAL);
                        }
                        positie++;
                        break;
                default:
                        drukc(c);
                        positie++;
                        break;
        }
        vorige = c;    /* vorige letter onthouden */
        /* Kijk of we over het einde van een regel zijn */
        if (positie == breed) {
                drukc('\n');
                positie = 0;
                regel++;
        }
        /* Kijk of we over het einde van een bladzijde zijn */
        if (regel == hoog) {
                drukc('\f');
                regel = 0;
                blz++;
        }
}

