/*********************** UNDER CONSTRUCTION *******************/

/* gebruikt fopensock.c en gethttp.c */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>	/* o.a. voor srand() */
#include <ctype.h>
#include <netdb.h>	/* voor gethostbyname() */
#include <unistd.h>	/* voor sleep() en mkdir() */
#include <sys/stat.h>	/* voor mkdir() */
#include <fcntl.h>	/* voor mkdir() */
#include <time.h>	/* voor time() */
#include "gethttp.h"

#ifdef __unix__
	#define SEPARATORCHAR '/'
#else
	#define SEPARATORCHAR '\\'
#endif

#define STATUS_TEHALEN 0	/* moet nog ingelezen worden */
#define STATUS_GELEZEN 1	/* is al ingelezen en bewaard */

int htmlfirst = 0;
int randomorder = 0;
int lynx = 0;

struct Pagina {
	struct Pagina *volgende;
	int status;
	/* pagina bevat de url van de pagina relatief tov de / van de server
	 * bv: als pagina=="~geert/mijndir/hier.html" en de startpagina is
	 * "zeus.rug.ac.be/~geert/index.html" dan is de op te halen pagina
	 * "http://zeus.rug.ac.be/~geert/mijndir/hier.html". */
	char pagina[1];
};

static long bytesRead = 0;

/* gelinkte lijst van nog in te lezen of al ingelezen pagina's */
static struct Pagina *paginas = NULL;

/* Zoek de eerste nog in te lezen pagina. */
static struct Pagina *zoekPagina(char *path) {
	struct Pagina *zoek;

	if (randomorder) {
		/* willekeurige eruit halen */
		int aantal = 0;
		for (zoek = paginas; zoek; zoek = zoek->volgende)
			if (zoek->status == STATUS_TEHALEN)
				aantal++;
		aantal = (int)(rand() * (float)aantal / (RAND_MAX+1.0));
		for (zoek = paginas; zoek; zoek = zoek->volgende)
			if (zoek->status == STATUS_TEHALEN) {
				if (aantal == 0) return zoek;
				aantal--;
			}
	}

	for (zoek = paginas; zoek; zoek = zoek->volgende)
		if (zoek->status == STATUS_TEHALEN)
			return zoek;
	return NULL;
}

void callback(long bytes) {
	putchar('#');
	fflush(stdout);
}

/* Probeer alle subdirectories naar een bestand te maken.
 * bv geert/ergens/bestand.html -> maak "geert" en "geert/ergens" dirs */
void makedirs(char *fname) {
	char *scan;
	for (scan = fname; *scan; scan++) {
		if (*scan != '/') continue;
		*scan = 0;	/* tijdelijk */
		mkdir(fname,0777);
		*scan = '/';	/* herstellen */
	}
}

/* bv filename("~geert/ergens","~geert/ergens/tekening.gif")
 * geeft "tekening.gif" */
char *filename(const char *path,const char *fname) {
	static char result[255];

	if (strncmp(path,fname,strlen(path))) return NULL;
	/* sla path en '/' over */
	fname += strlen(path);
	if (fname[0] == '/') fname++;

	if (fname[strlen(fname)-1]=='/' || !fname[0]) {
		/* bestand "blabla/" schrijven gaat niet;
		 * schrijf dus in "blabla/index.html" */
		sprintf(result,"%sindex.html",fname);
	} else
		strcpy(result,fname);
	return result;
}

/* bv schrijf("~geert/ergens","~geert/ergens/tekening.gif",...) */
void schrijf(const char *path,const char *fname,struct httpDocument *doc) {
	FILE *out;

	char *nam = filename(path,fname);
	if (!nam) return;
	makedirs(nam);
	out = fopen(nam,"w");
	if (!out) {
		printf("\tKan bestand %s niet schrijven\n",nam);
		return;
	}
	printf("\tschrijf %s...\n",nam);
	fwrite(doc->body,doc->bodyLength,1,out);
	fclose(out);
}

static char *strcasestr(const char *hooiberg,const char *naald) {
	int naaldlen = strlen(naald);

	while (*hooiberg) {
		if (!strncasecmp(hooiberg,naald,naaldlen))
			return (char *)hooiberg;
		hooiberg++;
	}
	return NULL;
}

static struct Pagina *findpag(const char *pag) {
	struct Pagina *snuffel;

	for (snuffel = paginas; snuffel; snuffel = snuffel->volgende) {
		if (!strcmp(pag,snuffel->pagina)) return snuffel;
	}
	return NULL;
}

/* resultaat is de nieuwe pagina */
static struct Pagina *addpagvooraan(const char *pag) {
	struct Pagina *result;

	result = findpag(pag);
	if (result) return result;	/* pagina is al in de lijst */
	result = malloc(sizeof(struct Pagina)+strlen(pag));
	result->volgende = paginas;
	result->status = STATUS_TEHALEN;
	strcpy(result->pagina,pag);
	paginas = result;
	return result;
}

static struct Pagina *addpagachteraan(const char *pag) {
	struct Pagina *result,*snuffel;

	result = findpag(pag);
	if (result) return result;	/* pagina is al in de lijst */
	result = malloc(sizeof(struct Pagina)+strlen(pag));
	strcpy(result->pagina,pag);
	result->volgende = NULL;
	result->status = STATUS_TEHALEN;
	/* achteraan toevoegen; zoek laatste pagina uit de lijst */
	for (snuffel = paginas; snuffel; snuffel = snuffel->volgende) {
		if (!snuffel->volgende) {
			snuffel->volgende = result;
			return result;
		}
	}
	/* we komen hier uit als de lijst leeg was */
	paginas = result;
	return result;
}

static int ishtml(char *url) {
	if (!strcasecmp(url+strlen(url)-4,".htm")) return 1;
	if (!strcasecmp(url+strlen(url)-5,".html")) return 1;
	if (!strcasecmp(url+strlen(url)-6,".shtml")) return 1;
	return 0;
}

/* Zoek links die in een HTML pagina staan en voeg ze toe aan de lijst.
 * Een link herkennen we aan	HREF = blabla	of	SRC = blabla
 * bv zoeklinks("~geert/ergens","hier.html",...) */
static void zoeklinks(const char *path,const char *thispage,struct httpDocument *doc) {
	char *snuffel = doc->body;

	while (1) {
		char *urlstart;
		char newurl[1024];

		{	char *zoekhref = strcasestr(snuffel,"HREF");
			char *zoeksrc = strcasestr(snuffel,"SRC");

			if (!zoekhref && !zoeksrc) break;
			if (zoekhref && zoeksrc) {
				snuffel = zoekhref<zoeksrc ? zoekhref : zoeksrc;
			} else snuffel = zoekhref ? zoekhref : zoeksrc;
			if (snuffel == zoekhref)
				snuffel += 4;	/* sla "HREF" over */
			else
				snuffel += 3;	/* sla "SRC" over */
		}

		while (isspace(*snuffel)) snuffel++;
		if (*snuffel != '=') continue;
		snuffel++;	/* sla '=' over */
		while (isspace(*snuffel)) snuffel++;
		if (*snuffel == '"') {	/* HREF="blablabla" */
			urlstart = ++snuffel;
			while (*snuffel && *snuffel!='\n' && *snuffel!='"')
				snuffel++;
		} else {	/* HREF=blablabla */
			urlstart = snuffel;
			while (*snuffel && *snuffel!='\n' && !isspace(*snuffel) && *snuffel!='>')
				snuffel++;
		}
		/* URL reikt vanaf urlstart tot (en zonder) snuffel
		 * Deze URL is relatief tov de / van de server
		 * tenzij het een absolute URL is (a la http://enz) */
		{	char *scan;

			for (scan = urlstart; scan < snuffel; scan++) {
				if (*scan == ':') {
					scan = NULL; break;
				} else if (*scan == '#') {
					/* verwijder #label suffix */
					snuffel = scan; break;
				}
			}
			if (!scan)	/* Er staat een : in, dus absolute URL */
				continue;
		}
		/* Nu zijn we zeker dat het een relatieve URL is.
		 * Wat is de volledige URL?
		 * dir van	deze url	-> volledige URL
		 * deze pagina
		 * hier		daar.html	hier/daar.html
		 * hier		../daar.html	daar.html
		 * hier		../../daar	(overslaan)
		 * hier/bla	daar.html	hier/daar.html
		 * hier/bla	../daar.html	daar.html */
		/* Begin met "hier" */
		strcpy(newurl,thispage);
		{	/* "hier/" of "hier/index.html" -> "hier" */
			char *lastslash = newurl;
			char *scan;

			for (scan = newurl; *scan; scan++)
				if (*scan == '/') lastslash = scan;
			*lastslash = 0;
		}
		/* Verwerk "../" en "./"; nieuwurl bevat de 'huidige directory' */
		while (urlstart && *urlstart=='.') {
			if (urlstart[1]=='/')
				urlstart += 2;	/* sla "./" over */
			else if (urlstart[1]=='.' && urlstart[2]=='/') {
				char *lastslash = NULL;
				char *scan;

				urlstart += 3;	/* sla "../" over */
				/* een directory zakken in newurl
				 * bv newurl=="lala/bla/hier" -> "lala/bla" */
				for (scan = newurl; *scan; scan++)
					if (*scan == '/') lastslash = scan;
				if (!lastslash) {
					if (newurl[0]) {
						/* pad="blabla" --> zak naar "" */
						lastslash = newurl;
					} else {
						/* pad="" --> kan niet lager zakken */
						urlstart = NULL;
						break;
					}
				}
				*lastslash = 0;	/* een dir zakken */
			}
		}
		if (!urlstart) continue;	/* was te laag gezakt */
		strcat(newurl,"/");
		strncat(newurl,urlstart,snuffel-urlstart);
		if (urlstart[0]=='/') {
			/* alle moeite voor niks: absolute link op de server */
			strncpy(newurl,urlstart+1,snuffel-urlstart-1);
			newurl[snuffel-urlstart-1] = 0;
		}
		if (strncmp(newurl,path,strlen(path))) return;
		printf("\t->%s\n",newurl);
		if (!htmlfirst) addpagachteraan(newurl);
		else if (ishtml(newurl))
			/* HTML pagina's vooraan */
			addpagvooraan(newurl);
		if (newurl[strlen(newurl)-1] == '/')
			/* dir overzichten vooraan */
			addpagvooraan(newurl);
		else
			/* Tekeningen (.gif, .jpg) pas op het einde laden. */
			addpagachteraan(newurl);
	}
}

/* Druk wat status info af. */
static void stats(void) {
	struct Pagina *snuffel;
	int gelezenhtml = 0,gelezentot = 0;
	int telezenhtml = 0,telezentot = 0;
	for (snuffel = paginas; snuffel; snuffel = snuffel->volgende) {
		if (ishtml(snuffel->pagina)) {
			/* html */
			if (snuffel->status == STATUS_GELEZEN) gelezenhtml++;
			else telezenhtml++;
		}
		if (snuffel->status == STATUS_GELEZEN) gelezentot++;
		else telezentot++;
	}
	printf("Read: %ld bytes %d files (%d of which html)\n",
		bytesRead,gelezentot,gelezenhtml);
	printf("To read: %d files (%d of which html)\n",
		telezentot,telezenhtml);
}

int main(int argc,char **argv) {
	char *hostname;
	char *path;
	char *startpage;
	int wachttijd;

	/* opties verwerken */
	while (argc >= 2) {
		if (!strcmp(argv[1],"htmlfirst")) {
			/* download eerst de HTML files, en de tekeningen
			 * op het einde */
			htmlfirst = 1;
		} else if (!strcmp(argv[1],"randomorder")) {
			/* download pagina's in willekeurige volgorde */
			randomorder = 1;
			srand(time(NULL));
		} else if (!strcmp(argv[1],"lynx")) {
			/* Maak niet zelf een connectie, maar gebruik
			 * het programma Lynx */
			lynx = 1;
		} else break;
		/* eet eerste argument op */
		argv++; argc--;
	}

	if (argc == 2) wachttijd = 10;
	else if (argc == 3) wachttijd = atoi(argv[2]);
	else if (argc < 2) {
		puts("Gebruik: suckhttp [htmlfirst] [randomorder] [lynx] hostnaam/pad/startpagina [wachttijd]\n"
			"\twachttijd is standaard 10 seconden.");
		return 10;
	}

	/* bepaal hostname,path,startpage
	 * hostname/path/path/startpage --> hostname path/path startpage */
	{
		char *scan = argv[1];
		char *start, *end;

		start = scan;
		while (*scan) {
			if (*scan == '/') break;
			scan++;
		}
		if (*scan != '/') {
			puts("Geen / na de hostnaam gevonden!");
			return 10;
		}
		hostname = malloc(scan-start+1);
		strncpy(hostname,start,scan-start);
		hostname[scan-start] = 0;

		scan++;		/* '/' overslaan */
		end = NULL;
		start = scan;
		while (*scan) {
			if (*scan == '/') end = scan;
			scan++;
		}
		/* end wijst naar laatste '/' */
		if (!end) {
			/* iets a la  http://server/index.html */
			end = start;
		}
		path = malloc(end-start+1);
		strncpy(path,start,end-start);
		path[end-start] = 0;

		if (end == start) scan = start = end;	/* geen path */
		else scan = start = end+1;	/* '/' van path overslaan */
		while (*scan) scan++;
		startpage = malloc(scan-start+1);
		strncpy(startpage,start,scan-start); 
		startpage[scan-start] = 0;
	}

	paginas = malloc(sizeof(struct Pagina) + strlen(path) + 1 + strlen(startpage));
	paginas->volgende = NULL;
	paginas->status = STATUS_TEHALEN;
	strcpy(paginas->pagina,path);
	strcat(paginas->pagina,"/");
	strcat(paginas->pagina,startpage);

	while (1) {
		int wacht;

		/* zoek een paginap */
		struct Pagina *lees = zoekPagina(path);
		char pagnaam[1024];
		struct httpDocument *httpdoc;
		int algelezen = 0;

		if (!lees) break;
		{	char *pag = lees->pagina;
			while (*pag == '/') pag++;
			sprintf(pagnaam,"/%s",pag);
		}
		printf("Lees http://%s%s...",hostname,pagnaam); fflush(stdout);
		{
			char *nam = filename(path,lees->pagina);
			FILE *f;
			if (!nam) {
				puts("<verkeerd pad>");
				lees->status = STATUS_GELEZEN;
				continue;
			}
			f = fopen(nam,"r");
			wacht = 0;
			if (f) {
				printf("<al gelezen>");
				algelezen = 1;
			} else if (!lynx) {
				struct hostent *h = gethostbyname(hostname);
				if (!h) {
					puts("!onbekende host!");
					return 10;
				}
				httpdoc = gethttp(h,pagnaam,callback);
				wacht = wachttijd;
			} else {
				char commando[255];
				makedirs(nam);
				sprintf(commando,"lynx -source \"http://%s%s\" > %s",
					hostname,pagnaam,nam);
				system(commando);
				wacht = wachttijd;
				f = fopen(nam,"r");
				if (!f) {
					puts("Kan pagina niet lezen!");
					lees->status = STATUS_GELEZEN;
					continue;
				}
			}
			if (f) {
				/* is al gedownload (tijdens een vorige
				 * sessie van suckhttp misschien); lees van
				 * de file */
				int len;
				fseek(f,0,SEEK_END);
				len = ftell(f);
				fseek(f,0,SEEK_SET);
				httpdoc = malloc(sizeof(struct httpDocument) + len);
				httpdoc->header = malloc(10);
				strcpy(httpdoc->header," 200 OK");
				httpdoc->bodyLength = len;
				httpdoc->body = malloc(len+1);
				fread(httpdoc->body,len,1,f);
				httpdoc->body[len] = 0;
				fclose(f);
			}
		}
		putchar('\n');
		lees->status = STATUS_GELEZEN;
		if (!httpdoc) {
			printf("\t!leesfout! (host=%s pagina=%s)\n",
				hostname,pagnaam);
			continue;
		}
		if (!strstr(httpdoc->header," 200 ")) {
			char *scan = httpdoc->header;
			printf("\tHTTP fout: (host=%s,pagina=%s)\n",
				hostname,pagnaam);
			/* eerste lijn afdrukken */
			while (*scan && *scan!='\n') putchar(*scan++);
			putchar('\n');
			freeHttpDocument(httpdoc);
			continue;
		}
		if (!algelezen) {
			/* Bewaren */
			bytesRead += httpdoc->bodyLength;
			schrijf(path,lees->pagina,httpdoc);
		}
		/* Zoek naar nieuwe pagina's */
		zoeklinks("",lees->pagina,httpdoc);
		freeHttpDocument(httpdoc);
		stats();
		if (wacht) sleep(wacht);
	}

	return 0;
}

